var versionURL = 'http://mobile.vesti.ru/nokia/ver';
var updateURL = 'http://mobile.vesti.ru/nokia/vesti.wgz';
var currentVersion = '5';
var feedsURL = 'http://c.digitala.ru/ovi/json';

var PID = '';
var INTERVAL = 24*60*60*1000;

var HS_VIEW_TRESHOLD = 150;
var HS_DID = 0;
var HS_ID = 0;
var HS_CHECK_TIMER = null;
var HS_UPDATE_TIMER = null;

var defaultsFeeds = [
	{'title': 'Самые быстрые новости, доступные в виде статей, фото и видео репортажей.', 'tag': 'главная'},
	{'title': 'Главные события дня, новости спорта и экономики, актуальная информация о фондовом рынке', 'tag': 'новости дня'},
	{'title': 'Удобный способ быть в курсе событий, где бы вы не находились.', 'tag': 'экономика'}
];

var Views = {
	0: ['LOADING_VIEW',     'Intro'],
	1: ['LIST_VIEW',        'List'],
	2: ['SLIDE_VIEW',       'Slides'],
	3: ['ONE_NEW_VIEW',     'NewsOne'],
	4: ['ONE_MARKET_VIEW',  'MarketsOne'],
	5: ['ONE_VIDEO_VIEW',   'VideoOne'],
	6: ['ERROR_VIEW',       'Errors'],
	7: ['HOME_SCREEN_VIEW', 'HomeScreen'],
};

var Tags = {
	'главная':     'Main',
	'новости дня': 'News',
	'экономика':   'Finance',
	'спорт':       'Sport',
	'fininfo':     'Markets'
};

var viewMode = 'SLIDE_MODE';
var feeds;
var currentView;

var checkUpdatesInProgress=0;

$(document).ready(function(){
	if (window.widget) {
		// принудительно landscape
		widget.setDisplayLandscape();
		widget.setNavigationEnabled(false);
		menu.hideSoftkeys();
	}
	

	PID = Math.round(Math.random() * 999999999) + 1000000000;
	loadPreferences();
	
	checkViewMode();
	updateHomeScreen();
	setInterval(updateHomeScreen,5000);
	
	$(window).resize(function(){
		checkViewMode();
	});
});

function checkViewMode() {
	hideAllViews();
	if (window.widget) {
		widget.setNavigationEnabled(false);
		menu.hideSoftkeys();
	}
	
	var isInHSView = isHSViewMode();

	if ( isInHSView ) {
		showView(7);
	} else {
		setActiveStyle();
		if ((typeof(feeds) != 'undefined') && (feeds.length > 0)) {
			if (viewMode == 'LIST_MODE') {
				switch (currentView) {
					case 'ONE_NEW_VIEW':
						showView(3);
						break;
					case 'ONE_MARKET_VIEW':
						showView(4);
						break;
					case 'ONE_VIDEO_VIEW':
						showView(5);
						break;
					default:
						showView(1);
						break;
				}
			}
			if (viewMode == 'SLIDE_MODE') {
				switch (currentView) {
					case 'ONE_NEW_VIEW':
						showView(3);
						break;
					case 'ONE_MARKET_VIEW':
						showView(4);
						break;
					case 'ONE_VIDEO_VIEW':
						showView(5);
						break;
					default:
						showView(2);
						break;
				}
			}
		} else {
			if ( typeof widget.preferenceForKey("PID") == 'undefined' ) {
				//show disclamer
				if (!confirm("Использование сервиса требует передачи данных через Интернет. Стоимость передачи данных уточняйте у своего оператора связи и интернет-провайдера. Продолжить?")) {
					appClose();
					return false;
				} else {
					showView(0);
					checkUpdates();
				}
			} else {
				showView(0);
				checkUpdates();
			}
			
		}
		
	}
}
var isHSViewMode = function() {
   var size = this.getScreenSize();
   return ( size.height < HS_VIEW_TRESHOLD );
};
function getScreenSize() {
	var height = window.innerHeight;
	var width = window.innerWidth;
	return {
		width: width,
		height: height
	};
}
function setActiveStyle() {
	var size = getScreenSize();
	if ( size.width >= 640 && size.height >= 360 ) {
		$('#PORTRAIT').attr('disabled', 'true');
		$('#LANDSCAPE').attr('disabled', '');
		return;
	}
	$('#LANDSCAPE').attr('disabled', 'true');
	$('#PORTRAIT').attr('disabled', '');
}
function checkUpdates() {
	if(checkUpdatesInProgress){return;}
	checkUpdatesInProgress=1;
	widget.setPreferenceForKey(PID, "PID");
	//netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	$.ajax(
		{
		    "type": "GET",
		    "url": versionURL + '?id='+PID,
			"dataType": "text",
			"success": function(data, textStatus, XMLHttpRequest) {
				if ( XMLHttpRequest.status == '200' ) {
					checkUpdatesInProgress=0;
					var new_version = ( typeof(data)!='undefined' && data.length > 0 ) ? data : currentVersion;
					
					if (currentVersion != new_version) {
						var targetDiv = $('#ErrorContent').get();
						$(targetDiv).empty();
						hideAllViews();
						showView(6);
						$(targetDiv).append('<p>Доступна новая версия. Пожалуйста обновите ее <a href="#" onclick="getNewVersion();appClose();return false">здесь</a> и перезапустите приложение.</p>');
					} else {
						getFeeds();
					}
				} else {
					appClose();
				}
				return;
			},
		    "error": function(XMLHttpRequest, textStatus, errorThrown) {
				checkUpdatesInProgress=0;
		        getFeedsError();
				return;
		    }
		}
	);
}
function getFeeds() {
	//netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	$.ajax(
		{
		    "type": "GET",
		    "url": feedsURL,
			"dataType": "json",
			"success": function(json) {
				feeds = json;
				$("#SlideNewsList ul").empty();
				$("#SlidesWrapper").empty();
				buildNews();
				updateHomeScreen();
				return;
			},
		    "error": function(XMLHttpRequest, textStatus, errorThrown) {
		        getFeedsError();
				return;
		    }
		}
	);
}
function getFeedsError() {
	var errorDiv = $('#ErrorContent').get();
	$(errorDiv).empty();
	$(errorDiv).append(
		'<p>Извините, произошла ошибка. Попробуйте перезапустить приложение.</p>'
	);
	hideAllViews();
	showView(6);
}
function buildNews() {
	if (viewMode == 'LIST_MODE') {
		var targetDiv = $("#SlideNewsList ul").get();
		$(targetDiv).empty();
		for (var feed in feeds) {
			var tag = feeds[feed].tag;
			if (tag == 'авто.вести.ru') {
				continue;
			}
			var title = '';
			var video = '';
			var image = '';
			var date = '';
			if (tag != 'fininfo') {
				video = feeds[feed].video;
				image = feeds[feed].image;
				date = formatDate(feeds[feed].date);
			}
			
			title = feeds[feed].title;
			
			$(targetDiv).append(
				'<li class="' + Tags[tag] + '">' +
				'<a onclick="javascript:buildOneNew(' +feed +');return false" href="#">' +
					title +
				'</a>' +
				'</li>'
			);
		}
		hideAllViews();
		showView(1);
	}
	if (viewMode == 'SLIDE_MODE') {
		var targetDiv = $("#SlidesWrapper").get();
		$(targetDiv).empty();
		var topMenu = $('#SlidesMenu').get();
	
		var count = 0;
		var num = feeds.length;
	
		for ( var feed in feeds ) {
			var tag = feeds[feed].tag;
			
			if (tag == 'авто.вести.ru') {
				continue;
			}
			var title = ''; var video = ''; var image = ''; var date = '';
			if ( tag != 'fininfo' ) {
				video = feeds[feed].video;
				date = formatDate(feeds[feed].date);
			}
			image = feeds[feed].image;
			title = feeds[feed].title;
			
			var prevArrow = '';
			var nextArrow = '';
			var rigthBtn = '';
	
			prevArrow = '<a href="#" class="Prev01" onclick="javascript:prevSlide();return false">Prev</a>';
			nextArrow = '<a href="#" class="Next01" onclick="javascript:nextSlide();return false">Next</a>';
			
			if (video && typeof(video) != 'undefined' && video != '') {
				rigthBtn = '<li class="OptionsMenuVideo"><a onclick="javascript:buildOneVideo('+feed+');return false" href="#">Видео</a></li>';
			} else {
				rigthBtn = '<li class="OptionsMenuEmpty"><i>Пусто</i></li>';
			}
			
			$(targetDiv).append(
				'<div style="display:none" id="Slide'+feed+'" class="Slide '+Tags[tag]+'">'+
					'<img onclick="javascript:buildOneNew('+feed+');return false" class="need_load" rel="'+image+'" src="img/loader2.gif">'+
					'<p><a href="#" onclick="javascript:buildOneNew('+feed+');return false">'+title+'<span>'+date+'</span></a></p>'+
					
					'<div class="Arrows'+Tags[tag]+'">'+
	                    prevArrow+
	                    nextArrow+
						'<div class="clr"></div>'+
	                '</div>'+
					
					'<div class="OptionsMenu">'+
	                    '<ul>'+
	                    	'<li class="OptionsMenuAllNews"><a href="#" onclick="javascript:showAsList();return false" >Все новости</a></li>'+
		                    '<li class="OptionsMenuRefresh"><a href="#" onclick="javascript:refreshNews();return false"><span>Обновить</span></a></li>'+
		                    rigthBtn+
	                    	'<div class="clr"></div>'+
	                    '</ul>'+
	                '</div>'+
					
				'</div>'
			);
			count++;
		}
		hideAllViews();
		showView(2);
		
		var firstSlide = $(targetDiv).find(':first-child');
		var firstSlideImg = $(firstSlide).find('img:first');
		var firstSlideImgSrc = $(firstSlideImg).attr('rel');
		
		$(firstSlideImg).attr('src', firstSlideImgSrc);
		$(firstSlideImg).removeClass('need_load');
		
		$(firstSlide).show();
		changeActiveMenuItem();
	}
}
function updateHomeScreen() {
	var targetDiv = $("#HomeScreen").get();
	var lfeeds;
	// если feeds нету, то используем рекламную
	if (typeof(feeds) == 'undefined' || feeds.length == 0) {
		lfeeds=defaultsFeeds;
	}else{
		lfeeds=feeds;
	}
	
	HS_ID++;
	if ( HS_ID >= lfeeds.length ){ HS_ID = 0; }
	var feed = lfeeds[HS_ID];
	var title = feed.title;
	var tag = feed.tag;

	$(targetDiv).empty();
	$(targetDiv).html('<i></i><p class="'+Tags[tag]+'" rel="'+HS_ID+'">'+title+'</p>');
}
function changeActiveMenuItem() {
	var targetDiv = $("#SlidesWrapper").get();
	var curSlide = $(targetDiv).find('.Slide:visible');
	
	if ( targetDiv.length == 0 || curSlide.length == 0 ) return;
	
	var item = $(curSlide).attr('class');
	item = item.replace(/Slide /g, '');

	var topMenu = $('#SlidesMenu').get();
	var ulList = $(topMenu).find('li');
	$(ulList).each(function(){
		var className = $(this).attr('class');

		if ( className == item+'Active' ) return;
		if ( className == item ) {
			className = className + 'Active';
		} else {
			className = className.replace(/Active/g, '');
		}
		$(this).attr('class', className);
	});
}
function goToCategory(type) {
	var targetDiv = $("#SlidesWrapper").get();
	var curSlide = $(targetDiv).find('.Slide:visible');
	if ( $(curSlide).hasClass(type) ) return;
	var toSlide = $(targetDiv).find('.Slide.'+type+':first');
	if ( targetDiv.length == 0 || curSlide.length == 0 || toSlide.length == 0 ) return;
	$(toSlide).show();
	$(curSlide).hide();
	
	changeActiveMenuItem();
	loadImage(toSlide);
}
function prevSlide() {
	var targetDiv = $("#SlidesWrapper").get();
	var curSlide = $(targetDiv).find('.Slide:visible');
	var prevSlide = $(curSlide).prev('.Slide');

	if ( targetDiv.length == 0 || curSlide.length == 0 || prevSlide.length == 0 ) return;
	
	$(prevSlide).show();
	$(curSlide).hide();
	
	changeActiveMenuItem();
	loadImage(prevSlide);
}
function nextSlide() {
	var targetDiv = $("#SlidesWrapper").get();
	var curSlide = $(targetDiv).find('.Slide:visible');
	var nextSlide = $(curSlide).next('.Slide');
	
	if ( targetDiv.length == 0 || curSlide.length == 0 || nextSlide.length == 0 ) return;
	
	$(nextSlide).show();
	$(curSlide).hide();
	
	changeActiveMenuItem();
	loadImage(nextSlide);
}
function loadImage(container) {
	var SlideImg = $(container).find('img:first');
	if ( SlideImg.length == 0 || $(SlideImg).attr('class') != 'need_load' ) return;
	var SlideImgSrc = $(SlideImg).attr('rel');
	
	$(SlideImg).attr('src', SlideImgSrc);
	$(SlideImg).removeClass('need_load');
}
function buildOneNew(one) {
	if ( typeof(feeds) == 'undefined' || typeof(feeds[one]) == 'undefined' ) return;
	
	hideAllViews();
	
	var feed = feeds[one];
	var tag = feed.tag;
	if ( tag == 'авто.вести.ru' ) return;
	var title = ''; var video = ''; var image = ''; var date = ''; var full_text;
	title = feed.title;
	date = formatDate(feed.date);
	
	if ( tag != 'fininfo' ) {
		var targetDiv = $('#NewsOne').get(); 
		$(targetDiv).empty();
	
		$(targetDiv).append(
			'<div class="Header">'+
				'<h1>ВЕСТИ</h1><a href="#" onclick="javascript:backToView();return false" class="Back">Назад</a><a href="#" onclick="javascript:appClose();return false" class="Close">Закрыть</a>'+
			'</div>'
		);

		full_text = feed.fulltext;
		full_text = full_text.replace(/\n/g, '<br/><br/>');
		video = feed.video;
		
		$(targetDiv).append(
			'<div class="New '+Tags[tag]+'">'+
				'<h2>'+title+'</h2>'+
				'<span>'+date+'</span>'+
				'<p>'+full_text+'</p>'+
			'</div>'
		);
		
		var btn = '';
		if (video && typeof(video) != 'undefined' && video != '') {
			btn = '<li class="OptionsMenuVideo"><a href="#" onclick="javascript:buildOneVideo('+one+');return false">Смотреть видео</a></li>';
		} else {
			btn = '<li class="OptionsMenuVideoEmpty"><i>Пусто</i></li>';
		}
		
		$(targetDiv).append(
			'<div class="OptionsMenu">'+
				'<ul>'+
					btn+
					'<li class="OptionsMenuEmpty"><i>Пусто</i></li>'+
					'<div class="clr"></div>'+
				'</ul>'+
			'</div>'
		);
		showView(3);
	} else {
		var targetDiv = $('#MarketsOne').get(); 
		$(targetDiv).empty();
		
		$(targetDiv).append(
			'<div class="Header">'+
				'<h1>ВЕСТИ</h1><a href="#" onclick="javascript:backToView();return false"  class="Back">Назад</a><a href="#" onclick="javascript:appClose();return false" class="Close">Закрыть</a>'+
			'</div>'
		);
		
		var values = feed.values;
		var rts = ''; var mm = ''; var forex = ''; var index = '';
		for ( var val in values ) {
			var count = values[val].value;
			var change = values[val].change;
			var name = values[val].name;
			var type = values[val].type;
			
			var class_name = 'Plus';
			var sign = '+';
			if ( change < 0 ) {class_name = 'Minus';sign=''}
			
			switch (type) {
				case 'RTS':
					rts += '<li>'+name+'<span class="Count">'+count+'</span><span class="Change '+class_name+'">'+sign+change+'</span></li>';
					break;
				case 'MM':
					mm += '<li>'+name+'<span class="Count">'+count+'</span><span class="Change '+class_name+'">'+sign+change+'</span></li>';
					break;
				case 'FOREX':
					forex += '<li>'+name+'<span class="Count">'+count+'</span><span class="Change '+class_name+'">'+sign+change+'</span></li>';
					break;
				case 'INDEX':
					index += '<li>'+name+'<span class="Count">'+count+'</span><span class="Change '+class_name+'">'+sign+change+'</span></li>';
					break;
			}
		}
		
		$(targetDiv).append(
			'<div class="Market">'+
				'<h2>'+title+'</h2>'+
				'<span>'+date+'</span>'+
				'<div id="MarketsOneIndexes">'+
					'<h3>РТС</h3><ul>'+
						rts+
					'</ul>'+
					'<h3>ММВБ</h3><ul>'+
						mm+
					'</ul>'+
					'<h3>FOREX</h3><ul>'+
						forex+
					'</ul>'+
					'<h3>Мировые индексы</h3><ul>'+
						index+
					'</ul>'+
				'</div>'+
			'</div>'+
			'<div class="OptionsMenu">'+
	            '<ul>'+
	            '<li class="OptionsMenuEmpty"><i>Пусто</i></li>'+
	            '<li class="OptionsMenuEmpty2"><i>Пусто</i></li>'+
	            '<div class="clr"></div>'+
	            '</ul>'+
	        '</div>'
		);
		showView(4);
	}
}
function buildOneVideo(one) {
	if ( typeof(feeds) == 'undefined' || typeof(feeds[one]) == 'undefined' ) return;
	
	hideAllViews();
	
	var feed = feeds[one];
	var tag = feed.tag;
	if ( tag == 'авто.вести.ru' || tag == 'fininfo' ) return;
	var title = ''; var video = ''; var image = ''; var date = ''; var full_text;
	title = feed.title;
	date = formatDate(feed.date);
	video = feed.video;
	
	var targetDiv = $('#VideoOne').get(); 
	$(targetDiv).empty();
	
	$(targetDiv).append(
		'<div class="Header">'+
			'<h1>ВЕСТИ</h1><a href="#" onclick="javascript:backToView();return false" class="Back">Назад</a><a href="#" onclick="javascript:appClose();return false" class="Close">Закрыть</a>'+
		'</div>'
	);
	
	if (video && typeof(video) != 'undefined' && video != '') {
		$(targetDiv).append(
			'<div class="Video '+Tags[tag]+'">'+
				'<h2>'+title+'</h2>'+
				'<span>'+date+'</span>'+
				'<div class="Movie">'+
					'<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" style="border:0;outline:none" width="320" height="290" id="MyFlash" align="middle">'+
				        '<param name="allowScriptAccess" value="sameDomain" />'+
				        '<param name="movie" value="player.swf" />'+
				        '<param name="loop" value="false" />'+
				        '<param name="menu" value="false" />'+
				        '<param name="quality" value="high" />'+
				        '<param name="wmode" value="opaque" />'+
				        '<param name="bgcolor" value="#ffffff" />'+
				        '<param name="flashvars" value="file='+video+'&largecontrols=true&autostart=true" />'+
				        '<embed src="player.swf" loop="false" menu="false" FlashVars="file='+video+'&largecontrols=true&autostart=true" quality="high" wmode="opaque" bgcolor="#ffffff" width="320" height="290" name="Finish" align="middle" allowScriptAccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" />'+
				    '</object>'+
				'</div>'+
			'</div>'+
			'<div class="OptionsMenu">'+
	            '<ul>'+
	            '<li class="OptionsMenuEmpty"><i>Пусто</i></li>'+
	            '<li class="OptionsMenuEmpty2"><i>Пусто</i></li>'+
	            '<div class="clr"></div>'+
	            '</ul>'+
	        '</div>'
		);
		
	}
	showView(5);
}
function backToView() {
	hideAllViews();
	$('#NewsOne').empty();
	$('#MarketsOne').empty();
	$('#VideoOne').empty();
	if ( viewMode == 'SLIDE_MODE' ) {
		showView(2);
	}
	if ( viewMode == 'LIST_MODE' ) {
		showView(1);
	}
}
function loadPreferences() {
    if (window.widget) {
		if (typeof widget.preferenceForKey("ViewMode") != 'undefined' && typeof widget.preferenceForKey("PID") != 'undefined') {
			viewMode = widget.preferenceForKey("ViewMode");
			PID = widget.preferenceForKey("PID");
		}
    }
}
function savePreferences() {
    if (window.widget) {
        widget.setPreferenceForKey(viewMode, "ViewMode");
		widget.setPreferenceForKey(PID, "PID");
    }
}
function hideAllViews() { $('.View').hide(); }
function showView(view_id) {
	currentView = Views[view_id][0];
	var id = Views[view_id][1];
	$('#' + id).show();
}
function showAsSlides() {
	viewMode = 'SLIDE_MODE';
	savePreferences();
	buildNews();
}
function showAsList() {
	viewMode = 'LIST_MODE';
	savePreferences();
	buildNews();
}
function formatDate(str) {
	var padZero = function(i) {
		if (i < 10) return "0" + i;
		return i;
	};
	var now = new Date();
	var months = {
		0:'января',1:'февраля',2:'марта',3:'апреля',4:'мая',5:'июня',
		6:'июля',7:'августа',8:'сентября',9:'октября',10:'ноября',11:'декабря'
	};
	var temp = new Date( str );
	
	if ( (now.getTime() - temp.getTime()) > INTERVAL ) {
		temp = temp.getDate() + ' ' + months[temp.getMonth()] + ' ' + temp.getFullYear();
		return temp;
	}
	temp = padZero(temp.getHours()) + ':' + padZero(temp.getMinutes());
	return temp;
}
function appClose() {
	window.close();
}
function getNewVersion() {
	if ( window.widget ) {
		widget.openURL(updateURL);
	}
}
function goToOvi() {
	if (window.widget) {
		widget.openURL('http://store.ovi.com');
	}
}
function refreshNews() {
	feeds = [];
	hideAllViews();
	//показываем div загрузки
	showView(0);
	checkUpdates();
}
